require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_BITOPS_H)) {
	eval 'sub _PPC_BITOPS_H () {1;}' unless defined(&_PPC_BITOPS_H);
	require 'linux/config.ph';
	require 'asm/byteorder.ph';
	if(defined(&CONFIG_SMP)) {
	    eval 'sub SMP_WMB () {"eieio\\n";}' unless defined(&SMP_WMB);
	    eval 'sub SMP_MB () {"\\nsync";}' unless defined(&SMP_MB);
	} else {
	    eval 'sub SMP_WMB () {1;}' unless defined(&SMP_WMB);
	    eval 'sub SMP_MB () {1;}' unless defined(&SMP_MB);
	}
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_clear_bit);
	if(defined(&__KERNEL__)) {
	    eval 'sub hweight32 {
	        local($x) = @_;
    		eval q( &generic_hweight32($x));
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        local($x) = @_;
    		eval q( &generic_hweight16($x));
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        local($x) = @_;
    		eval q( &generic_hweight8($x));
	    }' unless defined(&hweight8);
	}
	eval 'sub find_first_zero_bit {
	    local($addr, $size) = @_;
    	    eval q( &find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_bit);
	if(defined(&__KERNEL__)) {
	    eval 'sub ext2_set_bit {
	        local($nr, $addr) = @_;
    		eval q( &__test_and_set_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_set_bit);
	    eval 'sub ext2_clear_bit {
	        local($nr, $addr) = @_;
    		eval q( &__test_and_clear_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_clear_bit);
	    eval 'sub ext2_find_first_zero_bit {
	        local($addr, $size) = @_;
    		eval q( &ext2_find_next_zero_bit(($addr), ($size), 0));
	    }' unless defined(&ext2_find_first_zero_bit);
	    eval 'sub minix_test_and_set_bit {
	        local($nr,$addr) = @_;
    		eval q( &ext2_set_bit($nr,$addr));
	    }' unless defined(&minix_test_and_set_bit);
	    eval 'sub minix_set_bit {
	        local($nr,$addr) = @_;
    		eval q(( &ext2_set_bit($nr,$addr)));
	    }' unless defined(&minix_set_bit);
	    eval 'sub minix_test_and_clear_bit {
	        local($nr,$addr) = @_;
    		eval q( &ext2_clear_bit($nr,$addr));
	    }' unless defined(&minix_test_and_clear_bit);
	    eval 'sub minix_test_bit {
	        local($nr,$addr) = @_;
    		eval q( &ext2_test_bit($nr,$addr));
	    }' unless defined(&minix_test_bit);
	    eval 'sub minix_find_first_zero_bit {
	        local($addr,$size) = @_;
    		eval q( &ext2_find_first_zero_bit($addr,$size));
	    }' unless defined(&minix_find_first_zero_bit);
	}
    }
}
1;
