require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_IO_H)) {
	eval 'sub _PPC_IO_H () {1;}' unless defined(&_PPC_IO_H);
	require 'linux/config.ph';
	require 'linux/types.ph';
	require 'asm/page.ph';
	require 'asm/byteorder.ph';
	eval 'sub SIO_CONFIG_RA () {0x398;}' unless defined(&SIO_CONFIG_RA);
	eval 'sub SIO_CONFIG_RD () {0x399;}' unless defined(&SIO_CONFIG_RD);
	eval 'sub SLOW_DOWN_IO () {1;}' unless defined(&SLOW_DOWN_IO);
	eval 'sub PMAC_ISA_MEM_BASE () {0;}' unless defined(&PMAC_ISA_MEM_BASE);
	eval 'sub PMAC_PCI_DRAM_OFFSET () {0;}' unless defined(&PMAC_PCI_DRAM_OFFSET);
	eval 'sub CHRP_ISA_IO_BASE () {0xf8000000;}' unless defined(&CHRP_ISA_IO_BASE);
	eval 'sub CHRP_ISA_MEM_BASE () {0xf7000000;}' unless defined(&CHRP_ISA_MEM_BASE);
	eval 'sub CHRP_PCI_DRAM_OFFSET () {0;}' unless defined(&CHRP_PCI_DRAM_OFFSET);
	eval 'sub PREP_ISA_IO_BASE () {0x80000000;}' unless defined(&PREP_ISA_IO_BASE);
	eval 'sub PREP_ISA_MEM_BASE () {0xc0000000;}' unless defined(&PREP_ISA_MEM_BASE);
	eval 'sub PREP_PCI_DRAM_OFFSET () {0x80000000;}' unless defined(&PREP_PCI_DRAM_OFFSET);
	if(defined( &CONFIG_4xx)) {
	    require 'asm/ppc4xx.ph';
	}
 elsif(defined( &CONFIG_8xx)) {
	    require 'asm/mpc8xx.ph';
	}
 elsif(defined( &CONFIG_8260)) {
	    require 'asm/mpc8260.ph';
	}
 elsif(defined( &CONFIG_APUS)) {
	    eval 'sub _IO_BASE () {0;}' unless defined(&_IO_BASE);
	    eval 'sub _ISA_MEM_BASE () {0;}' unless defined(&_ISA_MEM_BASE);
	    eval 'sub PCI_DRAM_OFFSET () {0;}' unless defined(&PCI_DRAM_OFFSET);
	} else {
	    eval 'sub _IO_BASE () { &isa_io_base;}' unless defined(&_IO_BASE);
	    eval 'sub _ISA_MEM_BASE () { &isa_mem_base;}' unless defined(&_ISA_MEM_BASE);
	    eval 'sub PCI_DRAM_OFFSET () { &pci_dram_offset;}' unless defined(&PCI_DRAM_OFFSET);
	}
	eval 'sub readb {
	    local($addr) = @_;
    	    eval q( &in_8(($addr)));
	}' unless defined(&readb);
	eval 'sub writeb {
	    local($b,$addr) = @_;
    	    eval q( &out_8(($addr), ($b)));
	}' unless defined(&writeb);
	if(defined( &CONFIG_APUS)) {
	    eval 'sub readw {
	        local($addr) = @_;
    		eval q((* ($addr)));
	    }' unless defined(&readw);
	    eval 'sub readl {
	        local($addr) = @_;
    		eval q((* ($addr)));
	    }' unless defined(&readl);
	    eval 'sub writew {
	        local($b,$addr) = @_;
    		eval q(((* ($addr)) = ($b)));
	    }' unless defined(&writew);
	    eval 'sub writel {
	        local($b,$addr) = @_;
    		eval q(((* ($addr)) = ($b)));
	    }' unless defined(&writel);
	} else {
	    eval 'sub readw {
	        local($addr) = @_;
    		eval q( &in_le16(($addr)));
	    }' unless defined(&readw);
	    eval 'sub readl {
	        local($addr) = @_;
    		eval q( &in_le32(($addr)));
	    }' unless defined(&readl);
	    eval 'sub writew {
	        local($b,$addr) = @_;
    		eval q( &out_le16(($addr),($b)));
	    }' unless defined(&writew);
	    eval 'sub writel {
	        local($b,$addr) = @_;
    		eval q( &out_le32(($addr),($b)));
	    }' unless defined(&writel);
	}
	eval 'sub __raw_readb {
	    local($addr) = @_;
    	    eval q((*($addr)));
	}' unless defined(&__raw_readb);
	eval 'sub __raw_readw {
	    local($addr) = @_;
    	    eval q((*($addr)));
	}' unless defined(&__raw_readw);
	eval 'sub __raw_readl {
	    local($addr) = @_;
    	    eval q((*($addr)));
	}' unless defined(&__raw_readl);
	eval 'sub __raw_writeb {
	    local($v, $addr) = @_;
    	    eval q((*($addr) = ($v)));
	}' unless defined(&__raw_writeb);
	eval 'sub __raw_writew {
	    local($v, $addr) = @_;
    	    eval q((*($addr) = ($v)));
	}' unless defined(&__raw_writew);
	eval 'sub __raw_writel {
	    local($v, $addr) = @_;
    	    eval q((*($addr) = ($v)));
	}' unless defined(&__raw_writel);
	eval 'sub insb {
	    local($port, $buf, $ns) = @_;
    	    eval q( &_insb((($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&insb);
	eval 'sub outsb {
	    local($port, $buf, $ns) = @_;
    	    eval q( &_outsb((($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&outsb);
	eval 'sub insw {
	    local($port, $buf, $ns) = @_;
    	    eval q( &_insw_ns((($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&insw);
	eval 'sub outsw {
	    local($port, $buf, $ns) = @_;
    	    eval q( &_outsw_ns((($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&outsw);
	eval 'sub insl {
	    local($port, $buf, $nl) = @_;
    	    eval q( &_insl_ns((($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&insl);
	eval 'sub outsl {
	    local($port, $buf, $nl) = @_;
    	    eval q( &_outsl_ns((($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&outsl);
	if(defined(&CONFIG_ALL_PPC)) {
	    eval 'sub __do_in_asm {
	        local($name, $op) = @_;
    		eval q( &extern  &__inline__  &unsigned int name { \'unsigned int x\';  &__asm__  &__volatile__( $op \\"	%0,0,%1\\\\n\\" \\"1:	twi	0,%0,0\\\\n\\" \\"2:	isync\\\\n\\" \\"3:	nop\\\\n\\" \\"4:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"5:	li	%0,-1\\\\n\\" \\"	b	4b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align	2\\\\n\\" \\"	.long	1b,5b\\\\n\\" \\"	.long	2b,5b\\\\n\\" \\"	.long	3b,5b\\\\n\\" \\".previous\\" : \\"=&r\\" ( &x) : \\"r\\" ( &port +  &_IO_BASE));  &return  &x; });
	    }' unless defined(&__do_in_asm);
	    eval 'sub __do_out_asm {
	        local($name, $op) = @_;
    		eval q( &extern  &__inline__  &void $name(\'unsigned int val\', \'unsigned int port\') {  &__asm__  &__volatile__( $op \\" %0,0,%1\\\\n\\" \\"1:	sync\\\\n\\" \\"2:\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align	2\\\\n\\" \\"	.long	1b,2b\\\\n\\" \\".previous\\" : : \\"r\\" ( &val), \\"r\\" ( &port +  &_IO_BASE)); });
	    }' unless defined(&__do_out_asm);
	}
 elsif(defined( &CONFIG_APUS)) {
	    eval 'sub inb {
	        local($port) = @_;
    		eval q( &in_8((($port)+ &_IO_BASE)));
	    }' unless defined(&inb);
	    eval 'sub outb {
	        local($val, $port) = @_;
    		eval q( &out_8((($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outb);
	    eval 'sub inw {
	        local($port) = @_;
    		eval q( &in_be16((($port)+ &_IO_BASE)));
	    }' unless defined(&inw);
	    eval 'sub outw {
	        local($val, $port) = @_;
    		eval q( &out_be16((($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outw);
	    eval 'sub inl {
	        local($port) = @_;
    		eval q( &in_be32((($port)+ &_IO_BASE)));
	    }' unless defined(&inl);
	    eval 'sub outl {
	        local($val, $port) = @_;
    		eval q( &out_be32((($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outl);
	} else {
	    eval 'sub inb {
	        local($port) = @_;
    		eval q( &in_8((($port)+ &_IO_BASE)));
	    }' unless defined(&inb);
	    eval 'sub outb {
	        local($val, $port) = @_;
    		eval q( &out_8((($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outb);
	    eval 'sub inw {
	        local($port) = @_;
    		eval q( &in_le16((($port)+ &_IO_BASE)));
	    }' unless defined(&inw);
	    eval 'sub outw {
	        local($val, $port) = @_;
    		eval q( &out_le16((($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outw);
	    eval 'sub inl {
	        local($port) = @_;
    		eval q( &in_le32((($port)+ &_IO_BASE)));
	    }' unless defined(&inl);
	    eval 'sub outl {
	        local($val, $port) = @_;
    		eval q( &out_le32((($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outl);
	}
	eval 'sub inb_p {
	    local($port) = @_;
    	    eval q( &inb(($port)));
	}' unless defined(&inb_p);
	eval 'sub outb_p {
	    local($val, $port) = @_;
    	    eval q( &outb(($val), ($port)));
	}' unless defined(&outb_p);
	eval 'sub inw_p {
	    local($port) = @_;
    	    eval q( &inw(($port)));
	}' unless defined(&inw_p);
	eval 'sub outw_p {
	    local($val, $port) = @_;
    	    eval q( &outw(($val), ($port)));
	}' unless defined(&outw_p);
	eval 'sub inl_p {
	    local($port) = @_;
    	    eval q( &inl(($port)));
	}' unless defined(&inl_p);
	eval 'sub outl_p {
	    local($val, $port) = @_;
    	    eval q( &outl(($val), ($port)));
	}' unless defined(&outl_p);
	eval 'sub insw_ns {
	    local($port, $buf, $ns) = @_;
    	    eval q( &_insw_ns((($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&insw_ns);
	eval 'sub outsw_ns {
	    local($port, $buf, $ns) = @_;
    	    eval q( &_outsw_ns((($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&outsw_ns);
	eval 'sub insl_ns {
	    local($port, $buf, $nl) = @_;
    	    eval q( &_insl_ns((($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&insl_ns);
	eval 'sub outsl_ns {
	    local($port, $buf, $nl) = @_;
    	    eval q( &_outsl_ns((($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&outsl_ns);
	eval 'sub IO_SPACE_LIMIT () {~0;}' unless defined(&IO_SPACE_LIMIT);
	eval 'sub memset_io {
	    local($a,$b,$c) = @_;
    	    eval q( &memset(($a),($b),($c)));
	}' unless defined(&memset_io);
	eval 'sub memcpy_fromio {
	    local($a,$b,$c) = @_;
    	    eval q( &memcpy(,($b),($c)));
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    local($a,$b,$c) = @_;
    	    eval q( &memcpy(($a),($b),($c)));
	}' unless defined(&memcpy_toio);
	if(defined(&__KERNEL__)) {
	    eval 'sub ioremap_nocache {
	        local($addr, $size) = @_;
    		eval q( &ioremap(($addr), ($size)));
	    }' unless defined(&ioremap_nocache);
	    unless(defined(&CONFIG_APUS)) {
	    } else {
	    }
	    unless(defined(&CONFIG_APUS)) {
	    } else {
	    }
	    unless(defined(&CONFIG_APUS)) {
	    } else {
	    }
	    unless(defined(&CONFIG_APUS)) {
	    } else {
	    }
	    eval 'sub page_to_phys {
	        local($page) = @_;
    		eval q((($page -  &mem_map) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	    eval 'sub page_to_bus {
	        local($page) = @_;
    		eval q(( &page_to_phys($page) +  &PCI_DRAM_OFFSET));
	    }' unless defined(&page_to_bus);
	}
	eval 'sub iobarrier_rw () {
	    eval q( &eieio());
	}' unless defined(&iobarrier_rw);
	eval 'sub iobarrier_r () {
	    eval q( &eieio());
	}' unless defined(&iobarrier_r);
	eval 'sub iobarrier_w () {
	    eval q( &eieio());
	}' unless defined(&iobarrier_w);
	eval 'sub dma_cache_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
}
1;
