require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&_ASM_IRQ_H)) {
	eval 'sub _ASM_IRQ_H () {1;}' unless defined(&_ASM_IRQ_H);
	require 'linux/config.ph';
	require 'asm/machdep.ph';
	require 'asm/atomic.ph';
	if(defined( &CONFIG_4xx)) {
	    eval 'sub NR_IRQS () {32;}' unless defined(&NR_IRQS);
	    eval 'sub AIC_INT0 () {(0);}' unless defined(&AIC_INT0);
	    eval 'sub AIC_INT4 () {(4);}' unless defined(&AIC_INT4);
	    eval 'sub AIC_INT5 () {(5);}' unless defined(&AIC_INT5);
	    eval 'sub AIC_INT6 () {(6);}' unless defined(&AIC_INT6);
	    eval 'sub AIC_INT7 () {(7);}' unless defined(&AIC_INT7);
	    eval 'sub AIC_INT8 () {(8);}' unless defined(&AIC_INT8);
	    eval 'sub AIC_INT9 () {(9);}' unless defined(&AIC_INT9);
	    eval 'sub AIC_INT10 () {(10);}' unless defined(&AIC_INT10);
	    eval 'sub AIC_INT11 () {(11);}' unless defined(&AIC_INT11);
	    eval 'sub AIC_INT27 () {(27);}' unless defined(&AIC_INT27);
	    eval 'sub AIC_INT28 () {(28);}' unless defined(&AIC_INT28);
	    eval 'sub AIC_INT29 () {(29);}' unless defined(&AIC_INT29);
	    eval 'sub AIC_INT30 () {(30);}' unless defined(&AIC_INT30);
	    eval 'sub AIC_INT31 () {(31);}' unless defined(&AIC_INT31);
	}
 elsif(defined( &CONFIG_8xx)) {
	    eval 'sub NR_SIU_INTS () {16;}' unless defined(&NR_SIU_INTS);
	    eval 'sub NR_IRQS () {( &NR_SIU_INTS +  &NR_8259_INTS);}' unless defined(&NR_IRQS);
	    eval 'sub SIU_IRQ0 () {(0);}' unless defined(&SIU_IRQ0);
	    eval 'sub SIU_LEVEL0 () {(1);}' unless defined(&SIU_LEVEL0);
	    eval 'sub SIU_IRQ1 () {(2);}' unless defined(&SIU_IRQ1);
	    eval 'sub SIU_LEVEL1 () {(3);}' unless defined(&SIU_LEVEL1);
	    eval 'sub SIU_IRQ2 () {(4);}' unless defined(&SIU_IRQ2);
	    eval 'sub SIU_LEVEL2 () {(5);}' unless defined(&SIU_LEVEL2);
	    eval 'sub SIU_IRQ3 () {(6);}' unless defined(&SIU_IRQ3);
	    eval 'sub SIU_LEVEL3 () {(7);}' unless defined(&SIU_LEVEL3);
	    eval 'sub SIU_IRQ4 () {(8);}' unless defined(&SIU_IRQ4);
	    eval 'sub SIU_LEVEL4 () {(9);}' unless defined(&SIU_LEVEL4);
	    eval 'sub SIU_IRQ5 () {(10);}' unless defined(&SIU_IRQ5);
	    eval 'sub SIU_LEVEL5 () {(11);}' unless defined(&SIU_LEVEL5);
	    eval 'sub SIU_IRQ6 () {(12);}' unless defined(&SIU_IRQ6);
	    eval 'sub SIU_LEVEL6 () {(13);}' unless defined(&SIU_LEVEL6);
	    eval 'sub SIU_IRQ7 () {(14);}' unless defined(&SIU_IRQ7);
	    eval 'sub SIU_LEVEL7 () {(15);}' unless defined(&SIU_LEVEL7);
	    require 'asm/mpc8xx.ph';
	    unless(defined(&PIT_INTERRUPT)) {
		eval 'sub PIT_INTERRUPT () { &SIU_LEVEL0;}' unless defined(&PIT_INTERRUPT);
	    }
	    unless(defined(&CPM_INTERRUPT)) {
		eval 'sub CPM_INTERRUPT () { &SIU_LEVEL2;}' unless defined(&CPM_INTERRUPT);
	    }
	    unless(defined(&PCMCIA_INTERRUPT)) {
		eval 'sub PCMCIA_INTERRUPT () { &SIU_LEVEL6;}' unless defined(&PCMCIA_INTERRUPT);
	    }
	    unless(defined(&DEC_INTERRUPT)) {
		eval 'sub DEC_INTERRUPT () { &SIU_LEVEL7;}' unless defined(&DEC_INTERRUPT);
	    }
	    eval 'sub mk_int_int_mask {
	        local($IL) = @_;
    		eval q((1<< (7- ($IL/2))));
	    }' unless defined(&mk_int_int_mask);
	} else {
	    if(defined( &CONFIG_APUS)) {
		eval 'sub SYS_IRQS () {8;}' unless defined(&SYS_IRQS);
	    }
	    eval 'sub NR_IRQS () {256;}' unless defined(&NR_IRQS);
	    unless(defined(&CONFIG_8260)) {
		eval 'sub NUM_8259_INTERRUPTS () {16;}' unless defined(&NUM_8259_INTERRUPTS);
	    } else {
		eval 'sub NR_SIU_INTS () {64;}' unless defined(&NR_SIU_INTS);
		eval 'sub SIU_INT_SMC1 () {(0x04);}' unless defined(&SIU_INT_SMC1);
		eval 'sub SIU_INT_SMC2 () {(0x05);}' unless defined(&SIU_INT_SMC2);
		eval 'sub SIU_INT_FCC1 () {(0x20);}' unless defined(&SIU_INT_FCC1);
		eval 'sub SIU_INT_FCC2 () {(0x21);}' unless defined(&SIU_INT_FCC2);
		eval 'sub SIU_INT_FCC3 () {(0x22);}' unless defined(&SIU_INT_FCC3);
		eval 'sub SIU_INT_SCC1 () {(0x28);}' unless defined(&SIU_INT_SCC1);
		eval 'sub SIU_INT_SCC2 () {(0x29);}' unless defined(&SIU_INT_SCC2);
		eval 'sub SIU_INT_SCC3 () {(0x2a);}' unless defined(&SIU_INT_SCC3);
		eval 'sub SIU_INT_SCC4 () {(0x2b);}' unless defined(&SIU_INT_SCC4);
	    }
	}
	eval 'sub NR_MASK_WORDS () {(( &NR_IRQS + 31) / 32);}' unless defined(&NR_MASK_WORDS);
    }
}
1;
