require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_PGTABLE_H)) {
	eval 'sub _PPC_PGTABLE_H () {1;}' unless defined(&_PPC_PGTABLE_H);
	require 'linux/config.ph';
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/sched.ph';
	    require 'linux/threads.ph';
	    require 'asm/processor.ph';
	    require 'asm/mmu.ph';
	    require 'asm/page.ph';
	    if(defined( &CONFIG_4xx)) {
		eval 'sub update_mmu_cache {
		    local($vma, $addr, $pte) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&update_mmu_cache);
	    }
 elsif(defined( &CONFIG_8xx)) {
		eval 'sub __tlbia () {
		    eval q( &asm  &volatile (\\"tlbia\\" : : ));
		}' unless defined(&__tlbia);
		eval 'sub update_mmu_cache {
		    local($vma, $addr, $pte) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&update_mmu_cache);
	    } else {
	    }
	    eval 'sub flush_tlb_all () { &local_flush_tlb_all;}' unless defined(&flush_tlb_all);
	    eval 'sub flush_tlb_mm () { &local_flush_tlb_mm;}' unless defined(&flush_tlb_mm);
	    eval 'sub flush_tlb_page () { &local_flush_tlb_page;}' unless defined(&flush_tlb_page);
	    eval 'sub flush_tlb_range () { &local_flush_tlb_range;}' unless defined(&flush_tlb_range);
	    eval 'sub flush_cache_all () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_all);
	    eval 'sub flush_cache_mm {
	        local($mm) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_mm);
	    eval 'sub flush_cache_range {
	        local($mm, $a, $b) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_range);
	    eval 'sub flush_cache_page {
	        local($vma, $p) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_page);
	    eval 'sub flush_page_to_ram {
	        local($page) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_page_to_ram);
	}
	eval 'sub PMD_SHIFT () {22;}' unless defined(&PMD_SHIFT);
	eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
	eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
	eval 'sub PGDIR_SHIFT () {22;}' unless defined(&PGDIR_SHIFT);
	eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
	eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
	eval 'sub PTRS_PER_PTE () {1024;}' unless defined(&PTRS_PER_PTE);
	eval 'sub PTRS_PER_PMD () {1;}' unless defined(&PTRS_PER_PMD);
	eval 'sub PTRS_PER_PGD () {1024;}' unless defined(&PTRS_PER_PGD);
	eval 'sub USER_PTRS_PER_PGD () {( &TASK_SIZE /  &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
	eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
	eval 'sub USER_PGD_PTRS () {( &PAGE_OFFSET >>  &PGDIR_SHIFT);}' unless defined(&USER_PGD_PTRS);
	eval 'sub KERNEL_PGD_PTRS () {( &PTRS_PER_PGD- &USER_PGD_PTRS);}' unless defined(&KERNEL_PGD_PTRS);
	eval 'sub pte_ERROR {
	    local($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pte %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pte_val($e)));
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    local($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pmd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pmd_val($e)));
	}' unless defined(&pmd_ERROR);
	eval 'sub pgd_ERROR {
	    local($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pgd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pgd_val($e)));
	}' unless defined(&pgd_ERROR);
	eval 'sub VMALLOC_OFFSET () {(0x1000000);}' unless defined(&VMALLOC_OFFSET);
	eval 'sub VMALLOC_START () {((( &high_memory +  &VMALLOC_OFFSET) & ~( &VMALLOC_OFFSET-1)));}' unless defined(&VMALLOC_START);
	eval 'sub VMALLOC_VMADDR {
	    local($x) = @_;
    	    eval q((($x)));
	}' unless defined(&VMALLOC_VMADDR);
	eval 'sub VMALLOC_END () { &ioremap_bot;}' unless defined(&VMALLOC_END);
	if(defined( &CONFIG_4xx)) {
	    eval 'sub _PAGE_GUARDED () {0x001;}' unless defined(&_PAGE_GUARDED);
	    eval 'sub _PAGE_COHERENT () {0x002;}' unless defined(&_PAGE_COHERENT);
	    eval 'sub _PAGE_NO_CACHE () {0x004;}' unless defined(&_PAGE_NO_CACHE);
	    eval 'sub _PAGE_WRITETHRU () {0x008;}' unless defined(&_PAGE_WRITETHRU);
	    eval 'sub _PAGE_USER () {0x010;}' unless defined(&_PAGE_USER);
	    eval 'sub _PAGE_EXEC () {0x020;}' unless defined(&_PAGE_EXEC);
	    eval 'sub _PAGE_PRESENT () {0x040;}' unless defined(&_PAGE_PRESENT);
	    eval 'sub _PAGE_DIRTY () {0x100;}' unless defined(&_PAGE_DIRTY);
	    eval 'sub _PAGE_RW () {0x200;}' unless defined(&_PAGE_RW);
	    eval 'sub _PAGE_ACCESSED () {0x400;}' unless defined(&_PAGE_ACCESSED);
	}
 elsif(defined( &CONFIG_8xx)) {
	    eval 'sub _PAGE_PRESENT () {0x0001;}' unless defined(&_PAGE_PRESENT);
	    eval 'sub _PAGE_NO_CACHE () {0x0002;}' unless defined(&_PAGE_NO_CACHE);
	    eval 'sub _PAGE_SHARED () {0x0004;}' unless defined(&_PAGE_SHARED);
	    eval 'sub _PAGE_EXEC () {0x0008;}' unless defined(&_PAGE_EXEC);
	    eval 'sub _PAGE_GUARDED () {0x0010;}' unless defined(&_PAGE_GUARDED);
	    eval 'sub _PAGE_WRITETHRU () {0x0020;}' unless defined(&_PAGE_WRITETHRU);
	    eval 'sub _PAGE_RW () {0x0040;}' unless defined(&_PAGE_RW);
	    eval 'sub _PAGE_ACCESSED () {0x0080;}' unless defined(&_PAGE_ACCESSED);
	    eval 'sub _PAGE_HWWRITE () {0x0100;}' unless defined(&_PAGE_HWWRITE);
	    eval 'sub _PAGE_DIRTY () {0x0200;}' unless defined(&_PAGE_DIRTY);
	    eval 'sub _PAGE_USER () {0x0800;}' unless defined(&_PAGE_USER);
	} else {
	    eval 'sub _PAGE_PRESENT () {0x001;}' unless defined(&_PAGE_PRESENT);
	    eval 'sub _PAGE_HASHPTE () {0x002;}' unless defined(&_PAGE_HASHPTE);
	    eval 'sub _PAGE_USER () {0x004;}' unless defined(&_PAGE_USER);
	    eval 'sub _PAGE_GUARDED () {0x008;}' unless defined(&_PAGE_GUARDED);
	    eval 'sub _PAGE_COHERENT () {0x010;}' unless defined(&_PAGE_COHERENT);
	    eval 'sub _PAGE_NO_CACHE () {0x020;}' unless defined(&_PAGE_NO_CACHE);
	    eval 'sub _PAGE_WRITETHRU () {0x040;}' unless defined(&_PAGE_WRITETHRU);
	    eval 'sub _PAGE_DIRTY () {0x080;}' unless defined(&_PAGE_DIRTY);
	    eval 'sub _PAGE_ACCESSED () {0x100;}' unless defined(&_PAGE_ACCESSED);
	    eval 'sub _PAGE_EXEC () {0x200;}' unless defined(&_PAGE_EXEC);
	    eval 'sub _PAGE_RW () {0x400;}' unless defined(&_PAGE_RW);
	}
	unless(defined(&_PAGE_HASHPTE)) {
	    eval 'sub _PAGE_HASHPTE () {0;}' unless defined(&_PAGE_HASHPTE);
	    eval 'sub _PTE_NONE_MASK () { &_PAGE_ACCESSED;}' unless defined(&_PTE_NONE_MASK);
	} else {
	    eval 'sub _PTE_NONE_MASK () { &_PAGE_HASHPTE;}' unless defined(&_PTE_NONE_MASK);
	}
	unless(defined(&_PAGE_SHARED)) {
	    eval 'sub _PAGE_SHARED () {0;}' unless defined(&_PAGE_SHARED);
	}
	unless(defined(&_PAGE_HWWRITE)) {
	    eval 'sub _PAGE_HWWRITE () {0;}' unless defined(&_PAGE_HWWRITE);
	}
	eval 'sub _PAGE_CHG_MASK () {( &PAGE_MASK |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_PAGE_CHG_MASK);
	eval 'sub _PAGE_BASE () { &_PAGE_PRESENT |  &_PAGE_ACCESSED;}' unless defined(&_PAGE_BASE);
	eval 'sub _PAGE_WRENABLE () { &_PAGE_RW |  &_PAGE_DIRTY |  &_PAGE_HWWRITE;}' unless defined(&_PAGE_WRENABLE);
	eval 'sub _PAGE_KERNEL () { &_PAGE_BASE |  &_PAGE_WRENABLE |  &_PAGE_SHARED;}' unless defined(&_PAGE_KERNEL);
	eval 'sub _PAGE_IO () { &_PAGE_KERNEL |  &_PAGE_NO_CACHE |  &_PAGE_GUARDED;}' unless defined(&_PAGE_IO);
	eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_BASE);}' unless defined(&PAGE_NONE);
	eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER);}' unless defined(&PAGE_READONLY);
	eval 'sub PAGE_READONLY_X () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_EXEC);}' unless defined(&PAGE_READONLY_X);
	eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_RW);}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_SHARED_X () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_RW |  &_PAGE_EXEC);}' unless defined(&PAGE_SHARED_X);
	eval 'sub PAGE_COPY () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER);}' unless defined(&PAGE_COPY);
	eval 'sub PAGE_COPY_X () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_EXEC);}' unless defined(&PAGE_COPY_X);
	eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_KERNEL);}' unless defined(&PAGE_KERNEL);
	eval 'sub PAGE_KERNEL_RO () { &__pgprot( &_PAGE_BASE |  &_PAGE_SHARED);}' unless defined(&PAGE_KERNEL_RO);
	eval 'sub PAGE_KERNEL_CI () { &__pgprot( &_PAGE_IO);}' unless defined(&PAGE_KERNEL_CI);
	eval 'sub __P000 () { &PAGE_NONE;}' unless defined(&__P000);
	eval 'sub __P001 () { &PAGE_READONLY_X;}' unless defined(&__P001);
	eval 'sub __P010 () { &PAGE_COPY;}' unless defined(&__P010);
	eval 'sub __P011 () { &PAGE_COPY_X;}' unless defined(&__P011);
	eval 'sub __P100 () { &PAGE_READONLY;}' unless defined(&__P100);
	eval 'sub __P101 () { &PAGE_READONLY_X;}' unless defined(&__P101);
	eval 'sub __P110 () { &PAGE_COPY;}' unless defined(&__P110);
	eval 'sub __P111 () { &PAGE_COPY_X;}' unless defined(&__P111);
	eval 'sub __S000 () { &PAGE_NONE;}' unless defined(&__S000);
	eval 'sub __S001 () { &PAGE_READONLY_X;}' unless defined(&__S001);
	eval 'sub __S010 () { &PAGE_SHARED;}' unless defined(&__S010);
	eval 'sub __S011 () { &PAGE_SHARED_X;}' unless defined(&__S011);
	eval 'sub __S100 () { &PAGE_READONLY;}' unless defined(&__S100);
	eval 'sub __S101 () { &PAGE_READONLY_X;}' unless defined(&__S101);
	eval 'sub __S110 () { &PAGE_SHARED;}' unless defined(&__S110);
	eval 'sub __S111 () { &PAGE_SHARED_X;}' unless defined(&__S111);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub ZERO_PAGE {
	        local($vaddr) = @_;
    		eval q(( &virt_to_page( &empty_zero_page)));
	    }' unless defined(&ZERO_PAGE);
	}
	eval 'sub pte_none {
	    local($pte) = @_;
    	    eval q((( &pte_val($pte) & ~ &_PTE_NONE_MASK) == 0));
	}' unless defined(&pte_none);
	eval 'sub pte_present {
	    local($pte) = @_;
    	    eval q(( &pte_val($pte) &  &_PAGE_PRESENT));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    local($ptep) = @_;
    	    eval q( &do {  &set_pte(($ptep),  &__pte(0)); }  &while (0));
	}' unless defined(&pte_clear);
	eval 'sub pmd_none {
	    local($pmd) = @_;
    	    eval q((! &pmd_val($pmd)));
	}' unless defined(&pmd_none);
	eval 'sub pmd_bad {
	    local($pmd) = @_;
    	    eval q((( &pmd_val($pmd) & ~ &PAGE_MASK) != 0));
	}' unless defined(&pmd_bad);
	eval 'sub pmd_present {
	    local($pmd) = @_;
    	    eval q((( &pmd_val($pmd) &  &PAGE_MASK) != 0));
	}' unless defined(&pmd_present);
	eval 'sub pmd_clear {
	    local($pmdp) = @_;
    	    eval q( &do {  &pmd_val(*($pmdp)) = 0; }  &while (0));
	}' unless defined(&pmd_clear);
	eval 'sub pte_page {
	    local($x) = @_;
    	    eval q(( &mem_map+(( &pte_val($x) >>  &PAGE_SHIFT))));
	}' unless defined(&pte_page);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub pgd_clear {
	        local($xp) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pgd_clear);
	    eval 'sub pgd_page {
	        local($pgd) = @_;
    		eval q((  &__va( &pgd_val($pgd) &  &PAGE_MASK)));
	    }' unless defined(&pgd_page);
	    eval 'sub mk_pte {
	        local($page,$pgprot) = @_;
    		eval q(({  &pte_t  &pte;  &pte_val( &pte) = (($page -  &mem_map) <<  &PAGE_SHIFT) |  &pgprot_val($pgprot);  &pte; }));
	    }' unless defined(&mk_pte);
	    if((defined(&_PAGE_HASHPTE) ? &_PAGE_HASHPTE : 0) != 0) {
	    } else {
	    }
	    eval 'sub pte_same {
	        local($A,$B) = @_;
    		eval q(((( &pte_val($A) ^  &pte_val($B)) & ~ &_PAGE_HASHPTE) == 0));
	    }' unless defined(&pte_same);
	    eval 'sub pmd_page {
	        local($pmd) = @_;
    		eval q(( &pmd_val($pmd)));
	    }' unless defined(&pmd_page);
	    eval 'sub pgd_offset_k {
	        local($address) = @_;
    		eval q( &pgd_offset( &init_mm, $address));
	    }' unless defined(&pgd_offset_k);
	    eval 'sub pgd_index {
	        local($address) = @_;
    		eval q((($address) >>  &PGDIR_SHIFT));
	    }' unless defined(&pgd_index);
	    eval 'sub pgd_offset {
	        local($mm, $address) = @_;
    		eval q((($mm)-> &pgd +  &pgd_index($address)));
	    }' unless defined(&pgd_offset);
	    eval 'sub SWP_TYPE {
	        local($entry) = @_;
    		eval q((($entry). &val & 0x3f));
	    }' unless defined(&SWP_TYPE);
	    eval 'sub SWP_OFFSET {
	        local($entry) = @_;
    		eval q((($entry). &val >> 6));
	    }' unless defined(&SWP_OFFSET);
	    eval 'sub SWP_ENTRY {
	        local($type, $offset) = @_;
    		eval q((( &swp_entry_t) { ($type) | (($offset) << 6) }));
	    }' unless defined(&SWP_ENTRY);
	    eval 'sub pte_to_swp_entry {
	        local($pte) = @_;
    		eval q((( &swp_entry_t) {  &pte_val($pte) >> 2}));
	    }' unless defined(&pte_to_swp_entry);
	    eval 'sub swp_entry_to_pte {
	        local($x) = @_;
    		eval q((( &pte_t) { ($x). &val << 2}));
	    }' unless defined(&swp_entry_to_pte);
	    eval 'sub KERNELMAP_FULL_CACHING () {0;}' unless defined(&KERNELMAP_FULL_CACHING);
	    eval 'sub KERNELMAP_NOCACHE_SER () {1;}' unless defined(&KERNELMAP_NOCACHE_SER);
	    eval 'sub KERNELMAP_NOCACHE_NONSER () {2;}' unless defined(&KERNELMAP_NOCACHE_NONSER);
	    eval 'sub KERNELMAP_NO_COPYBACK () {3;}' unless defined(&KERNELMAP_NO_COPYBACK);
	    eval 'sub kern_addr_valid {
	        local($addr) = @_;
    		eval q((1));
	    }' unless defined(&kern_addr_valid);
	    eval 'sub io_remap_page_range () { &remap_page_range;}' unless defined(&io_remap_page_range);
	    eval 'sub pgtable_cache_init () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&pgtable_cache_init);
	}
    }
}
1;
