require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_UACCESS_H)) {
	eval 'sub _PPC_UACCESS_H () {1;}' unless defined(&_PPC_UACCESS_H);
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/sched.ph';
	    require 'linux/errno.ph';
	    require 'asm/processor.ph';
	    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
	    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
	    eval 'sub KERNEL_DS () {(( &mm_segment_t) { 0});}' unless defined(&KERNEL_DS);
	    eval 'sub USER_DS () {(( &mm_segment_t) { 1});}' unless defined(&USER_DS);
	    eval 'sub get_ds () {
	        eval q(( &KERNEL_DS));
	    }' unless defined(&get_ds);
	    eval 'sub get_fs () {
	        eval q(( ($current->{thread}->{fs})));
	    }' unless defined(&get_fs);
	    eval 'sub set_fs {
	        local($val) = @_;
    		eval q(( ($current->{thread}->{fs}) = ($val)));
	    }' unless defined(&set_fs);
	    eval 'sub segment_eq {
	        local($a,$b) = @_;
    		eval q((($a). &seg == ($b). &seg));
	    }' unless defined(&segment_eq);
	    eval 'sub __kernel_ok () {( &segment_eq( &get_fs(),  &KERNEL_DS));}' unless defined(&__kernel_ok);
	    eval 'sub __user_ok {
	        local($addr,$size) = @_;
    		eval q(((($size) <=  &TASK_SIZE) &&(($addr) <=  &TASK_SIZE-($size))));
	    }' unless defined(&__user_ok);
	    eval 'sub __access_ok {
	        local($addr,$size) = @_;
    		eval q(( &__kernel_ok ||  &__user_ok(($addr),($size))));
	    }' unless defined(&__access_ok);
	    eval 'sub access_ok {
	        local($type,$addr,$size) = @_;
    		eval q( &__access_ok(($addr),($size)));
	    }' unless defined(&access_ok);
	    eval 'sub get_user {
	        local($x,$ptr) = @_;
    		eval q( &__get_user_check(($x),($ptr),$sizeof{($ptr)}));
	    }' unless defined(&get_user);
	    eval 'sub put_user {
	        local($x,$ptr) = @_;
    		eval q( &__put_user_check(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
	    }' unless defined(&put_user);
	    eval 'sub __get_user {
	        local($x,$ptr) = @_;
    		eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
	    }' unless defined(&__get_user);
	    eval 'sub __put_user {
	        local($x,$ptr) = @_;
    		eval q( &__put_user_nocheck(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
	    }' unless defined(&__put_user);
	    eval 'sub __put_user_nocheck {
	        local($x,$ptr,$size) = @_;
    		eval q(({ \'long __pu_err\';  &__put_user_size(($x),($ptr),($size), &__pu_err);  &__pu_err; }));
	    }' unless defined(&__put_user_nocheck);
	    eval 'sub __put_user_check {
	        local($x,$ptr,$size) = @_;
    		eval q(({ \'long __pu_err\' = - &EFAULT;  &__typeof__(*($ptr)) * &__pu_addr = ($ptr);  &if ( &access_ok( &VERIFY_WRITE, &__pu_addr,$size))  &__put_user_size(($x), &__pu_addr,($size), &__pu_err);  &__pu_err; }));
	    }' unless defined(&__put_user_check);
	    eval 'sub __put_user_size {
	        local($x,$ptr,$size,$retval) = @_;
    		eval q( &do { $retval = 0;  &switch ($size) {  &case 1:  &__put_user_asm($x,$ptr,$retval,\\"stb\\");  &break;  &case 2:  &__put_user_asm($x,$ptr,$retval,\\"sth\\");  &break;  &case 4:  &__put_user_asm($x,$ptr,$retval,\\"stw\\");  &break;  &case 8:  &__put_user_asm2($x,$ptr,$retval);  &break;  &default:  &__put_user_bad(); } }  &while (0));
	    }' unless defined(&__put_user_size);
	    eval 'sub __m {
	        local($x) = @_;
    		eval q((*($x)));
	    }' unless defined(&__m);
	    eval 'sub __put_user_asm {
	        local($x, $addr, $err, $op) = @_;
    		eval q( &__asm__  &__volatile__( \\"1:	\\"$op\\" %1,0(%2)\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	li %0,%3\\\\n\\" \\"	b 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 2\\\\n\\" \\"	.long 1b,3b\\\\n\\" \\".previous\\" : \\"=r\\"($err) : \\"r\\"($x), \\"b\\"($addr), \\"i\\"(- &EFAULT), \\"0\\"($err)));
	    }' unless defined(&__put_user_asm);
	    eval 'sub __put_user_asm2 {
	        local($x, $addr, $err) = @_;
    		eval q( &__asm__  &__volatile__( \\"1:	stw %1,0(%2)\\\\n\\" \\"2:	stw %1+1,4(%2)\\\\n\\" \\"3:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"4:	li %0,%3\\\\n\\" \\"	b 3b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 2\\\\n\\" \\"	.long 1b,4b\\\\n\\" \\"	.long 2b,4b\\\\n\\" \\".previous\\" : \\"=r\\"($err) : \\"r\\"($x), \\"b\\"($addr), \\"i\\"(- &EFAULT), \\"0\\"($err)));
	    }' unless defined(&__put_user_asm2);
	    eval 'sub __get_user_nocheck {
	        local($x,$ptr,$size) = @_;
    		eval q(({ \'long __gu_err\',  &__gu_val;  &__get_user_size( &__gu_val,($ptr),($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
	    }' unless defined(&__get_user_nocheck);
	    eval 'sub __get_user_check {
	        local($x,$ptr,$size) = @_;
    		eval q(({ \'long __gu_err\' = - &EFAULT,  &__gu_val = 0;  &const  &__typeof__(*($ptr)) * &__gu_addr = ($ptr);  &if ( &access_ok( &VERIFY_READ, &__gu_addr,$size))  &__get_user_size( &__gu_val, &__gu_addr,($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
	    }' unless defined(&__get_user_check);
	    eval 'sub __get_user_size {
	        local($x,$ptr,$size,$retval) = @_;
    		eval q( &do { $retval = 0;  &switch ($size) {  &case 1:  &__get_user_asm($x,$ptr,$retval,\\"lbz\\");  &break;  &case 2:  &__get_user_asm($x,$ptr,$retval,\\"lhz\\");  &break;  &case 4:  &__get_user_asm($x,$ptr,$retval,\\"lwz\\");  &break;  &case 8:  &__get_user_asm2($x, $ptr, $retval);  &default: ($x) =  &__get_user_bad(); } }  &while (0));
	    }' unless defined(&__get_user_size);
	    eval 'sub __get_user_asm {
	        local($x, $addr, $err, $op) = @_;
    		eval q( &__asm__  &__volatile__( \\"1:	\\"$op\\" %1,0(%2)\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	li %0,%3\\\\n\\" \\"	li %1,0\\\\n\\" \\"	b 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 2\\\\n\\" \\"	.long 1b,3b\\\\n\\" \\".previous\\" : \\"=r\\"($err), \\"=r\\"($x) : \\"b\\"($addr), \\"i\\"(- &EFAULT), \\"0\\"($err)));
	    }' unless defined(&__get_user_asm);
	    eval 'sub __get_user_asm2 {
	        local($x, $addr, $err) = @_;
    		eval q( &__asm__  &__volatile__( \\"1:	lwz %1,0(%2)\\\\n\\" \\"2:	lwz %1+1,4(%2)\\\\n\\" \\"3:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"4:	li %0,%3\\\\n\\" \\"	li %1,0\\\\n\\" \\"	li %1+1,0\\\\n\\" \\"	b 3b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"	.align 2\\\\n\\" \\"	.long 1b,4b\\\\n\\" \\"	.long 2b,4b\\\\n\\" \\".previous\\" : \\"=r\\"($err), \\"=&r\\"($x) : \\"b\\"($addr), \\"i\\"(- &EFAULT), \\"0\\"($err)));
	    }' unless defined(&__get_user_asm2);
	    eval 'sub __copy_from_user {
	        local($to, $from, $size) = @_;
    		eval q( &__copy_tofrom_user(($to), ($from), ($size)));
	    }' unless defined(&__copy_from_user);
	    eval 'sub __copy_to_user {
	        local($to, $from, $size) = @_;
    		eval q( &__copy_tofrom_user(($to), ($from), ($size)));
	    }' unless defined(&__copy_to_user);
	    eval 'sub strlen_user {
	        local($str) = @_;
    		eval q( &strnlen_user(($str), 0x7ffffffe));
	    }' unless defined(&strlen_user);
	}
    }
}
1;
