require '_h2ph_pre.ph';

unless(defined(&_LINUX_SMB_FS_H)) {
    eval 'sub _LINUX_SMB_FS_H () {1;}' unless defined(&_LINUX_SMB_FS_H);
    require 'linux/smb.ph';
    eval 'sub SMB_IOC_GETMOUNTUID () { &_IOR(ord(\'u\'), 1,  &__kernel_old_uid_t);}' unless defined(&SMB_IOC_GETMOUNTUID);
    eval 'sub SMB_IOC_NEWCONN () { &_IOW(ord(\'u\'), 2, \'struct smb_conn_opt\');}' unless defined(&SMB_IOC_NEWCONN);
    eval 'sub SMB_IOC_GETMOUNTUID32 () { &_IOR(ord(\'u\'), 3,  &__kernel_uid32_t);}' unless defined(&SMB_IOC_GETMOUNTUID32);
    if(defined(&__KERNEL__)) {
	require 'linux/pagemap.ph';
	require 'linux/vmalloc.ph';
	require 'linux/smb_mount.ph';
	require 'asm/unaligned.ph';
	eval 'sub WVAL {
	    local($buf,$pos) = @_;
    	    eval q(( &le16_to_cpu( &get_unaligned((($buf) + ($pos))))));
	}' unless defined(&WVAL);
	eval 'sub DVAL {
	    local($buf,$pos) = @_;
    	    eval q(( &le32_to_cpu( &get_unaligned((($buf) + ($pos))))));
	}' unless defined(&DVAL);
	eval 'sub LVAL {
	    local($buf,$pos) = @_;
    	    eval q(( &le64_to_cpu( &get_unaligned((($buf) + ($pos))))));
	}' unless defined(&LVAL);
	eval 'sub WSET {
	    local($buf,$pos,$val) = @_;
    	    eval q( &put_unaligned( &cpu_to_le16(), (($buf) + ($pos))));
	}' unless defined(&WSET);
	eval 'sub DSET {
	    local($buf,$pos,$val) = @_;
    	    eval q( &put_unaligned( &cpu_to_le32(), (($buf) + ($pos))));
	}' unless defined(&DSET);
	eval 'sub LSET {
	    local($buf,$pos,$val) = @_;
    	    eval q( &put_unaligned( &cpu_to_le64(), (($buf) + ($pos))));
	}' unless defined(&LSET);
	eval 'sub smb_base {
	    local($buf) = @_;
    	    eval q((((($buf))+4)));
	}' unless defined(&smb_base);
	if(defined(&DEBUG_SMB_MALLOC)) {
	    require 'linux/slab.ph';
	} else {
	    eval 'sub smb_kmalloc {
	        local($s,$p) = @_;
    		eval q( &kmalloc($s,$p));
	    }' unless defined(&smb_kmalloc);
	    eval 'sub smb_kfree {
	        local($o) = @_;
    		eval q( &kfree($o));
	    }' unless defined(&smb_kfree);
	    eval 'sub smb_vmalloc {
	        local($s) = @_;
    		eval q( &vmalloc($s));
	    }' unless defined(&smb_vmalloc);
	    eval 'sub smb_vfree {
	        local($o) = @_;
    		eval q( &vfree($o));
	    }' unless defined(&smb_vfree);
	}
	eval 'sub SMB_F_LOCALWRITE () {0x02;}' unless defined(&SMB_F_LOCALWRITE);
	eval 'sub SMB_CAP_RAW_MODE () {0x0001;}' unless defined(&SMB_CAP_RAW_MODE);
	eval 'sub SMB_CAP_MPX_MODE () {0x0002;}' unless defined(&SMB_CAP_MPX_MODE);
	eval 'sub SMB_CAP_UNICODE () {0x0004;}' unless defined(&SMB_CAP_UNICODE);
	eval 'sub SMB_CAP_LARGE_FILES () {0x0008;}' unless defined(&SMB_CAP_LARGE_FILES);
	eval 'sub SMB_CAP_NT_SMBS () {0x0010;}' unless defined(&SMB_CAP_NT_SMBS);
	eval 'sub SMB_CAP_RPC_REMOTE_APIS () {0x0020;}' unless defined(&SMB_CAP_RPC_REMOTE_APIS);
	eval 'sub SMB_CAP_STATUS32 () {0x0040;}' unless defined(&SMB_CAP_STATUS32);
	eval 'sub SMB_CAP_LEVEL_II_OPLOCKS () {0x0080;}' unless defined(&SMB_CAP_LEVEL_II_OPLOCKS);
	eval 'sub SMB_CAP_LOCK_AND_READ () {0x0100;}' unless defined(&SMB_CAP_LOCK_AND_READ);
	eval 'sub SMB_CAP_NT_FIND () {0x0200;}' unless defined(&SMB_CAP_NT_FIND);
	eval 'sub SMB_CAP_DFS () {0x1000;}' unless defined(&SMB_CAP_DFS);
	eval 'sub SMB_CAP_LARGE_READX () {0x4000;}' unless defined(&SMB_CAP_LARGE_READX);
	eval 'sub SMB_MAX_AGE {
	    local($server) = @_;
    	    eval q(((($server)-> ($mnt->{ttl}) *  &HZ) / 1000));
	}' unless defined(&SMB_MAX_AGE);
	eval 'sub SMB_DIRCACHE_SIZE () {(( &PAGE_CACHE_SIZE/$sizeof{\'struct dentry\' }));}' unless defined(&SMB_DIRCACHE_SIZE);
	eval 'sub SMB_FIRSTCACHE_SIZE () {((( &SMB_DIRCACHE_SIZE * $sizeof{\'struct dentry\' } - $sizeof{\'struct smb_cache_head\'}) / $sizeof{\'struct dentry\' }));}' unless defined(&SMB_FIRSTCACHE_SIZE);
	eval 'sub SMB_DIRCACHE_START () {( &SMB_DIRCACHE_SIZE -  &SMB_FIRSTCACHE_SIZE);}' unless defined(&SMB_DIRCACHE_START);
    }
}
1;
